unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, WaveFFT, ExtDlgs, StdCtrls, ExtCtrls, XPMan, ABitmapEtcs, ABitmap,
  ABitmapFilters32, Math, jpeg, gldpng, ComCtrls, Buttons,
  KDrop;

type
  TForm1 = class(TForm)
    ScrollBox1: TScrollBox;
    Image1: TImage;
    Button1: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    Button2: TButton;
    Label1: TLabel;
    Edit1: TEdit;
    ProgressBar1: TProgressBar;
    SpeedButton1: TSpeedButton;
    SaveDialog1: TSaveDialog;
    KAddDrop1: TKAddDrop;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure LoadPicture(FileName:String);
    procedure KAddDrop1DropFiles(Sender: TObject; Target: TWinControl;
      DropFiles: TStrings);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

  PRGB = ^TRGB;
  TRGB = record
      B : Byte;
      G : Byte;
      R : Byte;
  end;

  TWaveRecord = packed record
      RIFF : Array [1..4] of char;
      FileSize : Cardinal;
      WaveFmt : Array [1..8] of char;
      DataBytes : Cardinal;
      DataType : Word;
      Channels : Word;
      SampleRate : Cardinal;
      BytesPerSecond : Cardinal;
      BytesPerSample : Word;
      Bitrate : Word;
      data : Array [1..4] of char;
      DataLength : Cardinal;
  end;


var
  Form1: TForm1;

implementation

uses Unit2, Unit3;

{$R *.dfm}

procedure TForm1.LoadPicture(FileName:String);
var
      Tmp : TPicture;
      x,y : Integer;
      line : PRGB;
      pY : Byte;
begin
      Tmp := TPicture.Create;

      Tmp.LoadFromFile(FileName);
      Image1.Picture.Bitmap.Assign(Tmp.Graphic);
      Image1.Picture.Bitmap.PixelFormat := pf24bit;

      for y := 0 to Image1.Picture.Height-1 do
      begin
            line := Image1.Picture.Bitmap.ScanLine[y];

            for x := 0 to Image1.Picture.Width-1 do
            begin
                  pY := Round( 0.298912 * line^.R + 0.586611 * line^.G + 0.114478 * line^.B );
                  line^.R := pY; line^.G := pY; line^.B := pY;
                  Inc(line);
            end;
      end;

      Button2.Enabled := true;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
      if OpenPictureDialog1.Execute then
      begin
            LoadPicture(OpenPictureDialog1.FileName);
      end;
end;

procedure TForm1.Button2Click(Sender: TObject);

function RoundSmallInt(r:Double):SmallInt;
begin
      if r > 32767 then Result := 32767
      else if r < -32768 then Result := -32768
      else Result := Round(r);
end;

procedure throw90(A,B:TBitmap);
var
      x,y : Integer;
begin
      B.Width := A.Height;
      B.Height := A.Width;

      for x := 0 to A.Width-1 do
      begin
            for y := 0 to A.Height-1 do
            begin
                  B.Canvas.Pixels[A.Height-Y,X] := A.Canvas.Pixels[X,Y];
            end;
      end;
end;

procedure MirrorX(A,B:TBitmap);
var
      C : TBitmap;
      x,y : Integer;
begin
      C := TBitmap.Create;
      try
            C.Assign(A);

            for x := 0 to A.Width-1 do
            begin
                  for y := 0 to A.Height-1 do
                  begin
                        B.Canvas.Pixels[C.Width-X,Y] := C.Canvas.Pixels[X,Y];
                  end;
            end;
      finally
            C.Free;
      end;
end;

procedure MirrorY(A,B:TBitmap);
var
      C : TBitmap;
      x,y : Integer;
begin
      C := TBitmap.Create;
      try
            C.Assign(A);

            for x := 0 to A.Width-1 do
            begin
                  for y := 0 to A.Height-1 do
                  begin
                        B.Canvas.Pixels[X,C.Height-Y] := C.Canvas.Pixels[X,Y];
                  end;
            end;
      finally
            C.Free;
      end;
end;

function FadeWeight(var Buffer:Array of Double):Integer;
var
      count : Integer;
      i : Integer;
      FadeIn, FadeOut : Integer;
begin
      count := Length(Buffer);

      FadeIn := Round(count * 1/4);
      FadeOut := Round(count * 3/4);

      for i := 0 to Count-1 do
      begin
            if (i <= FadeIn) or (i <= FadeOut) then
                  Buffer[i] := Buffer[i] * 0.5-0.5*cos(2*pi*(i*2)/Count);
      end;

      Result := FadeIn; // 1/4̒lԂ
end;

function RoundArcCos(A:Double):Double;
begin
      if A > 1 then A := 1
      else if A < -1 then A := -1;

      Result := A;
end;

procedure ProcessAngle(FirstValue:Double; var Data:Array of Double);
var
      theta : Array of Double;
      N : Integer;
      Buffer : Array of Double;
      i : Integer;
begin
      N := Length(Data);
      SetLength(theta, N div 2);
      SetLength(Buffer, N);

      // get angle
      for i := 0 to (N div 2)-1 do
      begin
            //theta[i] := Arccos(RoundArcCos((FirstValue * 1 * N)/((N-1) * (Data[i]+1E-300))));
            theta[i] := 0.707;
      end;

      // process
      for i := 0 to (N div 2)-1 do
      begin
            Buffer[i] := Data[i] * cos(theta[i]);
      end;

      for i := N div 2 to N-1 do
      begin
            Buffer[N-(i-N div 2)-1] := Data[i] * sin(theta[i-N div 2]);
      end;

      // copy
      for i := 0 to N-1 do Data[i] := Buffer[i];
end;

const
      CoVol = 5;
var

      Src : TABitmap;
      Img : TABitmap;
      i,y,x : Integer;
      Col : TColor;
      pY  : Double;
      rfftcount : Integer;
      crosscount : Integer;
      rfftbuffer : Array of Double;
      wavbuffer : Array of SmallInt;
      crossbuffer : Array of SmallInt;
      Writer : TFileStream;
      WaveRec : TWaveRecord;
      tmax : Integer;
      InvLum : Boolean;
      XMode, YMode : Boolean;
      BeforeValue : Double;
begin
      Writer := TFileStream.Create(Edit1.Text,fmOpenReadWrite or fmCreate);
      Src := TABitmap.Create;
      Img := TABitmap.Create;
      try
            // init
            rfftcount := Round(2 * Power(2,Ceil(log2(Image1.Picture.Height))));
            crosscount := Round(rfftcount / 4);

            tmax := rfftcount * Image1.Picture.Width;
            InvLum := CheckBox1.Checked;
            XMode := RadioGroup1.ItemIndex = 1;
            YMode := RadioGroup2.ItemIndex = 1;
            BeforeValue := 0;

            // get buffer
            SetLength(rfftbuffer,rfftcount);
            SetLength(wavbuffer, rfftcount);
            SetLength(crossbuffer, crosscount);

            // set wave header
            WaveRec.RIFF := 'RIFF';
            WaveRec.FileSize := tmax * 2 + sizeof(WaveRec);
            //WaveRec.FileSize := Round(tmax * 2 - 1/4 * (tmax-Image1.Picture.Width)) + sizeof(WaveRec);
            WaveRec.WaveFmt := 'WAVEfmt ';
            WaveRec.DataBytes := 16;
            WaveRec.DataType := 1;
            WaveRec.Channels := 1;
            WaveRec.SampleRate := 44100;
            WaveRec.BytesPerSecond := 44100 * 2;
            WaveRec.BytesPerSample := 2;
            WaveRec.Bitrate := 16;
            WaveRec.data := 'data';
            WaveRec.DataLength := tmax * 2;
            //WaveRec.DataLength := Round(tmax * 2- 1/4 * (tmax-Image1.Picture.Width));

            Writer.Write(WaveRec,sizeof(WaveRec));

            Src.Assign(Image1.Picture.Bitmap);
            Src.PixelFormat := pf32bit;

            if CheckBox2.Checked then MirrorX(Src,Src);
            if CheckBox3.Checked then MirrorY(Src,Src);

            // 90x|ď
            throw90(Src,Img);

            //img.Assign(src);
            //img.SaveToFile('x:\tmp.bmp');

            //Img.Assign(Image1.Picture.Bitmap);

            ProgressBar1.Max := Img.Height-1;

            for y := 0 to Img.Height-1 do
            begin
                  for i := 0 to rfftcount-1 do rfftbuffer[i] := 0;

                  for x := 0 to Img.Width-1 do
                  begin
                        Img.GetColor(x,y,Col);
                        pY := ((GetRValue(Col) + GetGValue(Col) + GetBValue(Col)) div 3);

                        if InvLum then pY := 255-pY;
                        if YMode then pY := Power(10,pY/255) * 3276.7 * 0.5;

                        //pY := 0;
                        // obt@ɋl߂Ă
                        if not XMode then rfftbuffer[x] := pY
                        else rfftbuffer[Round(Power(10,x/Img.Width)*rfftcount) div 20] := pY;
                  end;

                  if y > 0 then ProcessAngle(BeforeValue, rfftbuffer);

                  // tFFT
                  invrealfft(rfftcount, rfftbuffer);

                  BeforeValue := rfftbuffer[rfftcount-1];

                  // uhpdݕt
                  //FadeWeight(rfftbuffer);

                  // Rs[ƃuh
                  for i := 0 to rfftcount-1 do
                  begin
                        wavbuffer[i] := RoundSmallInt(Round(rfftbuffer[i]*CoVol));

                        {if i <= crosscount then
                        begin
                              wavbuffer[i] := crossbuffer[i] + wavbuffer[i];
                        end;
                        }
                  end;

                  // 
                  //Writer.Seek(-crosscount, soFromCurrent);
                  Writer.Write(PSmallInt(wavbuffer)^, Length(wavbuffer) * sizeof(Smallint));

                  // NXobt@iuhj
                  {for i := 0 to crosscount-1 do
                  begin
                        crossbuffer[i] := wavbuffer[rfftcount-crosscount+i];
                  end;
                  }

                  ProgressBar1.Position := y;
            end;

            ProgressBar1.Position := 0;

      finally
            Writer.Free;
            Src.Free;
            Img.Free;
      end;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
      if SaveDialog1.Execute then
      begin
            Edit1.Text := SaveDialog1.FileName;
      end;
end;

procedure TForm1.KAddDrop1DropFiles(Sender: TObject; Target: TWinControl;
  DropFiles: TStrings);
begin
      LoadPicture(DropFiles[0]);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
      Form2.Edit1.Text := Edit1.Text;
      Form2.showmodal;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
      Form3.showmodal;
end;

end.
