unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, WaveFFT, ABitmap, Math, Buttons;

const
  WM_SHOWED = WM_USER + 1;

type
  TForm2 = class(TForm)
    ControlBar1: TControlBar;
    Edit1: TEdit;
    Button1: TButton;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ProgressBar1: TProgressBar;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    ComboBox4: TComboBox;
    ComboBox3: TComboBox;
    SpeedButton1: TSpeedButton;
    TrackBar1: TTrackBar;
    SpeedButton2: TSpeedButton;
    Panel1: TPanel;
    Button2: TButton;
    SaveDialog1: TSaveDialog;
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    procedure WMShowed(var Message: TMessage); message WM_SHOWED;
  public
    { Public 錾 }
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

uses Unit1;

function Hanning(Len:Integer; Index:Integer):Double;
begin
      Result := 0.5 - 0.5 * cos (2*pi*Index/(Len-1));
end;

function Hamming(Len:Integer; Index:Integer):Double;
begin
      Result := 0.54 - 0.46 * cos (2*pi*Index/(Len-1));
end;

function Gaussian(Len:Integer; Index:Integer):Double;
const
      m = pi;
begin
      Result := exp(-(2*sqr(4))/sqr(Len-1) * sqr((Index-0.5)-(Len-1)/2));
      //exp(-(2*pi^2)/((n-1)^2) * ((x-0.5)-(n-1)/2)^2)
end;

function Blackman(Len:Integer; Index:Integer):Double;
begin
      Result := 0.42 + 0.5 * cos(2*pi*(Index-(Len-1)/2)/(Len-1)) + 0.08 * cos(4*pi*(Index-(Len-1)/2)/(Len-1))
end;

function Rectangler(Len:Integer; Index:Integer):Double;
begin
      Result := 1;
end;

procedure TForm2.Button1Click(Sender: TObject);
var
      Reader : TFileStream;
      Header : TWaveRecord;
      Buffer : Array of SmallInt;
      RealBuffer : Array of Double;
      AbsData : Array of Double;
      Count : Integer;
      Window : function (Len:Integer; Index:Integer):Double;
      i,x,y : Integer;
      Img : TABitmap;
      Vol : Double;
      pY : Byte;
      InvLum : Boolean;
      XLog, YLog : Boolean;
      NewY : Integer;
begin
      Reader := TFileStream.Create(Edit1.Text, fmOpenRead);
      Img := TABitmap.Create;
      try
            Reader.Read(Header, sizeof(Header));

            Count := (128 shl ComboBox2.ItemIndex);
            Vol := 0.001 * TrackBar1.Position / TrackBar1.Max;

            Img.Width := Ceil((Header.DataLength div sizeof(smallint)) / Count);
            Img.Height := Count div 2;

            Img.FillBMPrgb(00,00,00);

            InvLum := SpeedButton1.Down;
            XLog := ComboBox3.ItemIndex = 1;
            YLog := ComboBox4.ItemIndex = 1;

            SetLength(Buffer, Count);
            SetLength(RealBuffer, Count);
            SetLength(AbsData, Count div 2);

            for i := 0 to Count-1 do
            begin
                  Buffer[i] := 0;
                  RealBuffer[i] := 0;
                  if i < Count div 2 then AbsData[i] := 0;
            end;

            case ComboBox1.ItemIndex of
                  0 : Window := Hanning;
                  1 : Window := Hamming;
                  2 : Window := Blackman;
                  3 : Window := Rectangler;
                  4 : Window := Gaussian;
            end;

            x := 0;

            ProgressBar1.Max := Reader.Size div Count;

            // ǂݍ
            while (Reader.Position < Reader.Size) do
            begin
                  Reader.Read(PSmallInt(Buffer)^, Count);

                  // ֐
                  for i := 0 to Count-1 do
                  begin
                        RealBuffer[i] := Buffer[i] * Window(Count, i);
                  end;

                  // FFT
                  realfft(Count, RealBuffer);

                  // UXyNgvZ
                  for i := 0 to (Count div 2-1) do
                  begin
                        AbsData[i] := sqrt(sqr(RealBuffer[i]) + sqr(RealBuffer[Count-i-1]) + 0.0) * Vol;
                  end;

                  // 摜֋L^
                  for y := 0 to Count div 2-1 do
                  begin
                        pY := 255-RoundByte(Round(AbsData[y]));
                        if YLog then pY := 255-RoundByte(Round(20*log10(AbsData[y]/4)));

                        if InvLum then pY := 255-pY;

                        // log x
                        if (XLog) and (y > 0) then
                        begin
                              NewY := Img.Height-Round((log10(y)* (Count div 2-1) / log10(Count div 2-1)))-1;
                              Img.PutRGB(x div 2, NewY ,py,py,py);
                        end
                        else if (not XLog) then
                        begin
                              NewY := Img.Height-y-1;
                              Img.PutRGB(x div 2, NewY, py,py,py);
                        end;
                        //Img.Canvas.Pixels[x div 2,Img.Height-y-1] := RGB(pY,pY,pY);
                  end;

                  Inc(x);
                  ProgressBar1.Position := x;
            end;

            Image1.Picture.Assign(Img);
            ProgressBar1.Position := 0;

      finally
            Reader.Free;
            Img.Free;
      end;
end;

procedure TForm2.WMShowed(var Message: TMessage);
begin
      Application.ProcessMessages;
      Form2.Button1.Click;
end;

procedure TForm2.FormShow(Sender: TObject);
begin
      PostMessage(Handle, WM_SHOWED, 0, 0);
end;

procedure TForm2.SpeedButton2Click(Sender: TObject);
begin
      if SpeedButton2.Down then
      begin
            Image1.AutoSize := false;
            Image1.Align := alClient;
            Image1.Stretch := true;
      end else
      begin
            Image1.Stretch := false;
            Image1.AutoSize := true;
            Image1.Width := 10;
            Image1.Height := 10;
            Image1.Align := alNone;
      end;
end;

procedure TForm2.Button2Click(Sender: TObject);
begin
      if SaveDialog1.Execute then
      begin
            Image1.Picture.Bitmap.SaveToFile(SaveDialog1.FileName);
      end;
end;

end.
